# Find OpencCV
#
# OpenCV_INCLUDE_DIRS
# OpenCV_LIBRARIES
# OpenCV_FOUND
#
# OpenCV_${COMPONENT}_INCLUDE_DIR
# OpenCV_${COMPONENT}_LIBRARY
# OpenCV_VERSION
#

SET(OpenCV_COMPONENTS
    calib3d
    #contrib
    core
    features2d
    flann
    #gpu
    highgui
    imgproc
    #legacy
    ml
    objdetect
    ts
    video
    videoio
    videostab
    #imgcodecs
    )

FOREACH(COMPONENT ${OpenCV_COMPONENTS})
    STRING(TOLOWER ${COMPONENT} LOWERCOMPONENT)
    STRING(TOUPPER ${COMPONENT} UPPERCOMPONENT)

    FIND_PATH(OpenCV_${UPPERCOMPONENT}_INCLUDE_DIR NAMES opencv/cv.h)

    FIND_LIBRARY(OpenCV_${UPPERCOMPONENT}_LIBRARY NAMES opencv_${LOWERCOMPONENT})

    SET(${OpenCV_${UPPERCOMPONENT}_FOUND} 1)

    MARK_AS_ADVANCED(OpenCV_${UPPERCOMPONENT}_INCLUDE_DIR 
        OpenCV_${UPPERCOMPONENT}_LIBRARY OpenCV_${UPPERCOMPONENT}_FOUND)
ENDFOREACH(COMPONENT)

IF(NOT OpenCV_FIND_COMPONENTS)
    SET(OpenCV_FIND_COMPONENTS ${OpenCV_COMPONENTS})
ENDIF(NOT OpenCV_FIND_COMPONENTS)

SET(OpenCV_FOUND "YES")
FOREACH(COMPONENT ${OpenCV_FIND_COMPONENTS})
    STRING(TOLOWER ${COMPONENT} LOWERCOMPONENT)
    STRING(TOUPPER ${COMPONENT} UPPERCOMPONENT)


    IF(OpenCV_${UPPERCOMPONENT}_LIBRARY AND OpenCV_${UPPERCOMPONENT}_INCLUDE_DIR)
        LIST(APPEND OpenCV_LIBRARIES ${OpenCV_${UPPERCOMPONENT}_LIBRARY})
        LIST(APPEND OpenCV_INCLUDE_DIRS ${OpenCV_${UPPERCOMPONENT}_INCLUDE_DIR})
        MESSAGE(STATUS "found lib${LOWERCOMPONENT}: 
            -I${OpenCV_${UPPERCOMPONENT}_INCLUDE_DIR}, 
            ${OpenCV_${UPPERCOMPONENT}_LIBRARY}"
            )
    ELSE(OpenCV_${UPPERCOMPONENT}_LIBRARY AND OpenCV_${UPPERCOMPONENT}_INCLUDE_DIR)
        #SET(OpenCV_FOUND "NO")
        IF(OpenCV_FIND_REQUIRED)
            MESSAGE(STATUS "Beware: opencv component ${LOWERCOMPONENT} NOT found")
        ELSE(OpenCV_FIND_REQUIRED)
            MESSAGE(STATUS "opencv component ${LOWERCOMPONENT} NOT found")
        ENDIF(OpenCV_FIND_REQUIRED)
    ENDIF(OpenCV_${UPPERCOMPONENT}_LIBRARY AND OpenCV_${UPPERCOMPONENT}_INCLUDE_DIR)
ENDFOREACH(COMPONENT)

IF(OpenCV_INCLUDE_DIRS)
    LIST(REMOVE_DUPLICATES OpenCV_INCLUDE_DIRS)
ENDIF(OpenCV_INCLUDE_DIRS)

MARK_AS_ADVANCED(OpenCV_LIBRARIES OpenCV_INCLUDE_DIRS OpenCV_FOUND)
